/*
xpequ copyright (c) 2007-always Jan Panteltje

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "xpequ.h"

FD_xpequ *fdui;

pthread_t colors_thread;
pthread_attr_t *attributes;

int stop_colors_flag;

static FILE *fptr = 0;
static int red, green, blue;

void *colors_routine()
{
//int a, i;
char temp[80];

if(debug_flag)
	{
	fprintf(stderr, "colors_routine(): arg none, using stop_colors_flag=%d\n", stop_colors_flag);
	}


colors_running_flag = 1;

/* test for user action */
while(1)
	{
	if(stop_colors_flag)
		{
		colors_running_flag = 0;

		return 0;
		}	

//fprintf(stderr, "WAS colors_routine.\n");

	/* for RGB lights with col_pic */ 
	int pri_flag = 0;

	if(color_output_flag)
		{
		if(! fptr)
			{
			fptr = fopen(serial_device_name, "w");
			if(! fptr)
				{
				fprintf(stderr, "xpequ: idle_cb(): could not open serial device %s for write, aborting.\n", serial_device_name);

				exit(1);
				}

			// int set_port_parameters(int fd, int baudrate, char *device)
			if(! set_port_parameters(fileno(fptr), baudrate, serial_device_name) )
				{
				fprintf(stderr, "xpequ: idle_cb(): could not set baudrate %d, aborting\n", baudrate); 
	
				exit(1);
				}
			} /* end if ! fptr */

		red = peak_red;		// set in equaliser.c
		green = peak_green;
		blue = peak_blue;

		red = average_red;		// set in equaliser.c
		green = average_green;
		blue = average_blue;

		sprintf(temp, "R%d\n", red);
		if(pri_flag) fprintf(stderr, "sending temp=%s", temp);
		//size_t fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream);
		fwrite(temp, 1, strlen(temp) + 1, fptr);	

		sprintf(temp, "G%d\n", green);
		if(pri_flag) fprintf(stderr, "sending temp=%s", temp);
		fwrite(temp, 1, strlen(temp) + 1, fptr);	

		sprintf(temp, "B%d\n", blue);
		if(pri_flag) fprintf(stderr, "sending temp=%s\n", temp);
		fwrite(temp, 1, strlen(temp) + 1, fptr);	


		times_here_red = 0;
		avrg_red = 0.0;
		
		times_here_green = 0;
		avrg_green = 0.0;
		
		times_here_blue = 0;
		avrg_blue = 0.0;
		
//usleep(100000);		

		} /* end if color_output_flag */
	} /* end wile do colors */

/* never here */

colors_running_flag = 0;

return 0;
} /* end function colors_routine */


int stop_colors()
{
if(debug_flag)
	{
	fprintf(stderr, "stop_colors(): arg none.\n");
	}

stop_colors_flag = 1;

while(colors_running_flag)
	{
	usleep(10000);
	}

return 1;
} /* end function stop_colors */



int start_colors()
{
if(debug_flag)
	{
	fprintf(stderr,\
	"start_colors(): using serial device=%s baudrate=%d\n", serial_device_name, baudrate);
	}

stop_colors_flag = 0;
colors_running_flag = 0;

pthread_create(&colors_thread, NULL, &colors_routine, NULL);

if(debug_flag)
	{
	fprintf(stderr, "start_colors(): colors_started\n");
	}

return 1;
} /* end function start_colors */



