/*
xpequ copyright (c) 2007-always Jan Panteltje

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "xpequ.h"

FD_xpequ *fdui;

pthread_t internet_thread;
pthread_attr_t *attributes;

int stop_internet_flag;
char internet_host_name[4096];


int make_socket(unsigned short int port)
{
int sock;
struct sockaddr_in name;
     
/* Create the socket. */
sock = socket (PF_INET, SOCK_STREAM, 0);
if(sock < 0)
	{
	perror ("socket");
	return -1;
	}
     
/* Give the socket a name. */
name.sin_family = AF_INET;
name.sin_port = htons (port);
name.sin_addr.s_addr = htonl (INADDR_ANY);
if(bind(sock, (struct sockaddr *) &name, sizeof (name)) < 0)
	{
	perror ("bind");
	return -1;
	}
     
return sock;
} /* end function make_socket */


void *internet_routine()
{
int a, i;
int sock = 0;
fd_set active_fd_set, read_fd_set;
struct sockaddr_in clientname;
size_t size;
int new;
int bytes_read;
char inbuffer[INTERNET_BUFFER_SIZE];
char *ucbufptr;
struct timeval timeout;
int said_no_clients_flag;
int bytes_written;
struct sockaddr_in server;
int buffer_length = INTERNET_BUFFER_SIZE;
int bytes_received;
int optval;
socklen_t b;
char temp[INTERNET_BUFFER_SIZE];

if(debug_flag)
	{
	fprintf(stderr, "internet_routine(): arg none, using stop_internet_flag=%d\n", stop_internet_flag);
	}

retry:

if(internet_mode == INTERNET_SERVER)
	{
	/*
	if we get this:
	bind: Address already in use
	listen: Bad file descriptor
	then we retry until the socket is free
	*/	

	while(1)
		{
		/* Create the socket and set it up to accept connections. */
		sock = make_socket(internet_port);
		if(sock != -1) break;

		sleep(1);
		}

	if(listen(sock, MAX_LISTEN_QUEUE) < 0)
		{
		perror ("listen");
		return 0;
		}

#define REUSE_ADDR
#ifdef REUSE_ADDR
	b = sizeof(int);
	//int getsockopt (int SOCKET, int LEVEL, int OPTNAME, void *OPTVAL, socklen_t *OPTLEN-PTR)
	a = getsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &optval, &b); 
	if(debug_flag)
		{
		fprintf(stderr, "SO_REUSEADDR: a=%d optval=%d\n", a, optval); 
 		}
	
	optval = 1;
	//int setsockopt (int SOCKET, int LEVEL, int OPTNAME, void *OPTVAL, socklen_t OPTLEN);
	a = setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &optval, sizeof(int) );
	if(debug_flag)
		{
		fprintf(stderr, "setsockopt returned a=%d b=%d\n", a, b);
		}

	a = getsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &optval, &b); 
	if(debug_flag)
		{
		fprintf(stderr, "getsockopt: SO_REUSEADDR: a=%d optval=%d b=%d\n", a, optval, b); 
		}
#endif // REUSE_ADDR

	/* Initialize the set of active sockets. */
	FD_ZERO (&active_fd_set);
	FD_SET (sock, &active_fd_set);

	/* listen to user for commands */
	//FD_SET(fileno(stdin), &active_fd_set);     

	/* report */
	if(debug_flag)
		{
		fprintf(stderr, "internet_routine(): listening for connections on internet_port %d\n", internet_port);
		}
	}
if(internet_mode == INTERNET_CLIENT)	
     {
	/* Create the socket. */
	sock = socket(PF_INET, SOCK_STREAM, 0);
	if(sock < 0)
		{
		perror ("read_from_server(): socket (client)");
			
		internet_client_sock = 0;

		return 0;
		}
     
	/* Connect to the server. */
	init_sockaddr(&server, internet_server_name, internet_port);

	while(1)
		{
		a = connect(sock, (struct sockaddr *) &server, sizeof(server) );
		if(a < 0)
			{
			if(debug_flag)
				{
				perror ("read_from_server(): connect(client)");
				}

			internet_client_sock = 0;

//			close(sock);

//			return 0;
			}     
		
		if(a >= 0) break;
		sleep(1);
		}
	
	/* Initialize the set of active sockets. */
	FD_ZERO (&active_fd_set);
	FD_SET (sock, &active_fd_set);

	/* listen to user for commands */
	//FD_SET(fileno(stdin), &active_fd_set);     

	/* report */
	if(debug_flag)
		{
		fprintf(stderr,\
		"internet_routine(): connected to internet_server_name=%s internet_port=%d, waiting for accept.\n",\
		internet_server_name, internet_port);
		}

	/* identify to server */
	strcpy(temp, "xpequ -y");
	bytes_written = write(sock, temp, strlen(temp) );
	if(bytes_written < 0)
		{
		fprintf(stderr, "could not send temp=%s\n", temp);
		perror ("write");

		internet_client_sock = 0;	

		close(sock);
		return 0;
		}

	internet_client_sock = sock;
    }

/* test for connections and user action */
internet_clients = 0;
said_no_clients_flag = 0;
while(1)
	{
	if(stop_internet_flag)
		{
		internet_running_flag = 0;

		return 0;
		}	

	if(internet_mode == INTERNET_SERVER)
		{
		/* Block until input arrives on one or more active sockets. */
		read_fd_set = active_fd_set;

		/* not to fast, else in remote buttons bounce back due to status send back */
		timeout.tv_sec = 1;
		timeout.tv_usec = 0; //100000;
		a = select (FD_SETSIZE, &read_fd_set, NULL, NULL, &timeout);
		if(a < 0)
			{
			perror ("select");

			internet_running_flag = 0;
			return 0;
			}
		if(a == 0)/* timeout */     
			{
			/*fprintf(stderr, "server timeout\n");	*/
			/* basically we could return here and / or do something else */
			if(internet_clients == 0)
				{
				if(! said_no_clients_flag)
					{
					if(debug_flag)
						{
						fprintf(stderr, "No clients\n");
						}

					said_no_clients_flag = 1;
					internet_connected_flag = 0;
					}
				}
			else
				{
				said_no_clients_flag = 0;

				if(! internet_stream_flag)
					{
					/* send full status back to remote control client */
					send_status(internet_client_sock);
					}
				}
			continue;
			}

		/* Service all the sockets with input pending. */
		for(i = 0; i < FD_SETSIZE; ++i)
			{
			if(FD_ISSET (i, &read_fd_set) )
				{
				if(i == sock) /* Connection request on original socket. */
					{
					/* we only allow one remote to control the server */
					if(internet_clients < 1)
						{
						size = sizeof(clientname);
						new = accept(sock, (struct sockaddr *) &clientname, &size);
						if(new < 0)
							{
							perror ("accept");

							internet_running_flag = 0;

							internet_connected_flag = 0;

							return 0;
							}

						/* report connect */
						if(debug_flag)
							{
							fprintf (stderr, "Server: connect from host %s.\n", inet_ntoa(clientname.sin_addr) );
							}
/* hostname lookup */						

						strncpy(internet_host_name, inet_ntoa(clientname.sin_addr), 4095);

						/*this gives incorrect port why?	ntohs (clientname.sin_port));*/

						FD_SET (new, &active_fd_set);

						/* one client more */
						internet_clients++;
						} /* end if less the none client */
					}
				else /* Data arriving on an already-connected socket. */
					{
					internet_client_sock = i;

					errno = 0;
					bytes_read = read(i, inbuffer, INTERNET_BUFFER_SIZE);
					if(debug_flag)
						{
						fprintf(stderr, "server read(): bytes read=%d\n", bytes_read);
						}
					if(bytes_read < 0) /* read error */
						{
						perror ("read");
						if(errno == EAGAIN) continue;
						if(errno == EINTR) continue;

						/* drop this connection */
						FD_CLR (i, &active_fd_set);
						close(i);
	
						/* one client less */
						if(internet_clients > 0) internet_clients--;

						/* try next socket */
						continue;

//						return 0;
						}
					else if(bytes_read == 0) /* EOF */
						{
						FD_CLR (i, &active_fd_set);

						close (i);

						/* one client less */
						if(internet_clients > 0) internet_clients--;

//internet_running_flag = 0;
//return 0;

						/* try next socket */
						continue;
						}

					if(debug_flag)
						{						
						fprintf(stderr, "internet_routine(): received message=%s\n", inbuffer);
						}
				
					/* parse the received message */
					if(strncmp(inbuffer, "xpequ -y", 8) == 0)
						{
						/* send full status back to remote control client */
						send_status(i);
						}
					else
						{
						read_status(inbuffer);
						update_gui_flag = 1;						
						}
					}/* end if existing connection */
				}/* end if FD_ISSET */
			}/* end for server all connections */
		} /* end if internet_mode == INTERNET_SERVER */

	if(internet_mode == INTERNET_CLIENT)
		{
		/* Block until input arrives on one or more active sockets. */
		read_fd_set = active_fd_set;
	
		timeout.tv_sec = 1;
		timeout.tv_usec = 0;
		a = select (FD_SETSIZE, &read_fd_set, NULL, NULL, &timeout);
		if(a < 0)
			{
			perror ("select");

			internet_running_flag = 0;

			internet_connected_flag = 0;

			return 0;
			}
		if(a == 0)/* timeout */     
			{
/*			fprintf(stderr, "client select timeout\n");	*/
			continue;
			}

		/* check if socket has data */
		if(FD_ISSET (sock, &read_fd_set) )
			{
			/* read from socket */
			ucbufptr = inbuffer;
			bytes_received = 0;
			while(1)
				{
				/* read the data */
				bytes_read = read(sock, ucbufptr, buffer_length - bytes_received);
				if(bytes_read < 0)
					{
					/* Read error. */
					perror ("read_from_server(): read");
					if(errno == EAGAIN) continue;
					if(errno == EINTR) continue;

					internet_running_flag = 0;

					internet_connected_flag = 0;
					
					return 0;
					}
				else if(bytes_read == 0) /* EOF, connection closed by server */
					{
					fprintf(stderr, "read_from_server(): EOF detected\n");

					internet_client_sock = 0;

					close(sock);
					
					internet_running_flag = 0;

					internet_connected_flag = 0;

					/* retry */
					goto retry;

					/* go recursive */
//					internet_routine();

//					return 0;
					}
		
				/* Data read. */
				ucbufptr += bytes_read;
				bytes_received += bytes_read;

				if(debug_flag)
					{
					fprintf (stderr,\
					"read_from_server(): bytes_read=%d bytes_received=%d\n", bytes_read, bytes_received);
					}

				break;
				}/* end while read from socket */

			if(debug_flag)
				{
//				fprintf(stderr, "internet_client: read_from_server(): msg=%s bytes_received=%d\n", inbuffer, bytes_received);
				}
			
			/* check if server asked disconnect to avoid 'bind: Address already in use' */
			if(strncmp(inbuffer, "xpequ client disconnect", 23) == 0)
				{
				close(sock);

				internet_running_flag = 0;
				internet_connected_flag = 0;				

				/* make sure this instance of the server has actually stopped */
				sleep(1);

				/* retry next server */
				goto retry;
				} 

/*
if parse 'xpequ server stream stopped'  then stop audio in client.
*/

			if(internet_stream_flag)
				{
				if(! internet_stream_client_exit_flag)
					{
//					if(!audio_running_flag) start_audio();
					}

//				fwrite(inbuffer, 1, abuf_size, stdout);			

				memcpy(audiobuf, inbuffer, INTERNET_BUFFER_SIZE);
				new_audio_flag = 1;
				}
			else
				{
				/* parse data */
				if(! read_status(inbuffer) )
					{
					fprintf(stderr, "internet_routine: internet_client: read_from_server(): read_status failed.\n");

					internet_running_flag = 0;

					internet_connected_flag = 0;

					return 0;				
					}
				update_gui_flag = 1;

				}
			}/* end socket has data */

		} /* end if internet_mode == INTERNET_CLIENT */

	} /* end while wait for select */
	
/* never here */
internet_running_flag = 0;
return 0;
} /* end function internet_routine */


int stop_internet()
{
if(debug_flag)
	{
	fprintf(stderr, "stop_internet(): arg none.\n");
	}

stop_internet_flag = 1;

while(internet_running_flag)
	{
	usleep(10000);
	}

return 1;
} /* end function stop_internet */


int start_internet()
{
if(debug_flag)
	{
	fprintf(stderr,\
	"start_internet(): using internet_port=%d\n", internet_port);
	}

if(internet_mode == INTERNET_OFF) return 0;

stop_internet_flag = 0;
internet_running_flag = 0;

pthread_create(&internet_thread, NULL, &internet_routine, NULL);

if(debug_flag)
	{
	fprintf(stderr, "start_internet(): internet_started\n");
	}

return 1;
} /* end function start_internet */


int init_sockaddr(struct sockaddr_in *name, const char *hostname, unsigned short int port)
{
struct hostent *hostinfo;
     
if(debug_flag)
	{
	fprintf(stderr, "Getting host %s port %d by name.\n", hostname, port);
	}
	
name -> sin_family = AF_INET;
name -> sin_port = htons (port);
hostinfo = gethostbyname (hostname);
if (hostinfo == NULL)
	{
	fprintf (stderr, "Unknown host %s.\n", hostname);

	return 0;
	}

name -> sin_addr = *(struct in_addr *) hostinfo -> h_addr;

return 1;
} /* end function init_sockaddr */


int send_status(int socket)
{
int i;
char temp[INTERNET_BUFFER_SIZE];
char temp2[4096];
int bytes_written;

if(debug_flag)
	{
	fprintf(stderr, "send_status(): arg socket=%d\n", socket);
	}

strncpy(temp2, input_filename, 4096);
/* replace any spaces and funny characters by '_' */
for(i = 0; i < strlen(temp2); i++)
	{
	if(temp2[i] == ' ') temp2[i] = '_';
	if(temp2[i] == 0) break;
	}

/* audio settings */
/* last one must be space else '0' accumulates in temp2 */
sprintf(temp,\
"%d %d %d %d %d %d %d %d %d %d %d %d %.2f %d %d %d   %d %d %d %d %d  %d %d %d %d %d  %.2f  %.2f %.2f %.2f  %d %d  %d %d  %d %d  %.2f %d  %d  %d  %s %d ",\
audio_input_device_number,\
audio_output_device_number,\
off_time_10x_flag,\
equalizer_enable_flag,\
display_mode,\
level_enabled_output_flag,\
fft_log_scale_flag,\
audio_mode,\
audio_input_device_sub_number,\
audio_output_device_sub_number,\
scope_time_per_division_multiplier,\
scope_trigger_mode,\
scope_trigger_level,\
scope_auto_trigger_flag,
scope_sensitivity,\
agc_flag,\
equalizer_slider_value[0],\
equalizer_slider_value[1],\
equalizer_slider_value[2],\
equalizer_slider_value[3],\
equalizer_slider_value[4],\
equalizer_slider_value[5],\
equalizer_slider_value[6],\
equalizer_slider_value[7],\
equalizer_slider_value[8],\
equalizer_slider_value[9],\
equalizer_gain,\
threshold,\
on_milli_seconds,\
off_milli_seconds,\
command_line_input_device_specified_flag,\
command_line_output_device_specified_flag,\
output_flag,\
use_input_file_flag,\
dsp_speed,\
audio_channels,\
audio_peak_level,\
agc_init_flag,\
internet_clients,\
active_state,\
temp2,\
internet_stream_flag\
);

/* send tx buffer, password plus text */
bytes_written = write(socket, temp, strlen(temp) );
if(bytes_written < 0)
	{
	fprintf(stderr, "send_status(): could not send temp=%s ", temp);
	perror ("because");

	internet_client_sock = 0;
	
	close(socket);

	return 0;
	}

internet_connected_flag = 1;

return 1;
} /* end function send_status */


int read_status(char *buffer)
{
int a;
char temp2[4096];

if(debug_flag)
	{
	fprintf(stderr, "read_status(): buffer=%s\n", buffer);
	}

if(! buffer) return 0;

a = sscanf(buffer,\
"%d %d %d %d %d %d %d %d %d %d %d %d %lf %d %d %d  %d %d %d %d %d  %d %d %d %d %d  %lf  %lf %lf %lf  %d %d  %d %d  %d %d  %lf %d  %d  %d  %s %d",\
&remote_audio_input_device_number,\
&remote_audio_output_device_number,\
&off_time_10x_flag,\
&equalizer_enable_flag,\
&display_mode,\
&level_enabled_output_flag,\
&fft_log_scale_flag,\
&remote_audio_mode,\
&remote_audio_input_device_sub_number,\
&remote_audio_output_device_sub_number,\
&scope_time_per_division_multiplier,\
&scope_trigger_mode,\
&scope_trigger_level,\
&scope_auto_trigger_flag,\
&scope_sensitivity,\
&agc_flag,\
&equalizer_slider_value[0],\
&equalizer_slider_value[1],\
&equalizer_slider_value[2],\
&equalizer_slider_value[3],\
&equalizer_slider_value[4],\
&equalizer_slider_value[5],\
&equalizer_slider_value[6],\
&equalizer_slider_value[7],\
&equalizer_slider_value[8],\
&equalizer_slider_value[9],\
&equalizer_gain,\
&threshold,\
&on_milli_seconds,\
&off_milli_seconds,\
&remote_command_line_input_device_specified_flag,\
&remote_command_line_output_device_specified_flag,\
&remote_output_flag,\
&remote_use_input_file_flag,\
&dsp_speed,\
&audio_channels,\
&audio_peak_level,\
&agc_init_flag,\
&internet_clients,\
&active_state,\
temp2,\
&internet_stream_flag\
);

if(input_filename) free(input_filename);
input_filename = strsave(temp2);
if(! input_filename)
	{
	fprintf(stderr, "xpequ: read_status(): could not allocate space for input_filename, aborting.\n");

	exit(1);
	}

high_samples = on_milli_seconds / milli_seconds_per_sample;
low_samples = off_milli_seconds / milli_seconds_per_sample;

if(debug_flag)
	{
	fprintf(stderr, " read_status(): args read a=%d\n", a);	
	}

if(a != 42)
	{
	fprintf(stderr, "xpequ: read_status(): only a=%d arguments read of 42.\n", a);
	
	return 0;
	}


if(internet_mode == INTERNET_SERVER)
	{
	static int old_internet_stream_flag;
	
	if( (!internet_stream_flag) && old_internet_stream_flag ) /* request to stop streaming */
		{
//		XXXXXXXXXXXXXXXXXXXX		

/* confirm to client */

		}

	old_internet_stream_flag = internet_stream_flag;
	}

/* the remotes */

internet_connected_flag = 1;

save_equalizer(equalizer_filename);

save_audio_settings();

return 1;
} /* end function read_status */


int update_gui()
{
int a;
char temp[80];
double da;

if(debug_flag)
	{
	fprintf(stderr, "update_gui(): arg none, using everything.\n");
	}

set_display_filename(input_filename);

if(internet_mode == INTERNET_SERVER)
	{
//	fl_hide_object(fdui -> internet_stream_button); /* no access from server */
	}
else
	{
	fl_show_object(fdui -> internet_stream_button); /* only access from client */

//	fl_set_button(fdui -> internet_stream_button, internet_stream_flag);
	}

	
fl_set_button(fdui ->  off_time_x10_button, off_time_10x_flag);
set_off_slider_bounds();

fl_set_button(fdui -> equalizer_enable_button, equalizer_enable_flag);
set_equalizer_objects(equalizer_enable_flag);

set_display_mode_button_label(display_mode);

fl_set_button(fdui -> level_enabled_output_button, level_enabled_output_flag);
if(level_enabled_output_flag)
	{
	if(active_state)
		{
		fl_set_object_color(fdui -> level_enabled_output_button, FL_SPRINGGREEN, FL_SPRINGGREEN);
		}
	else
		{
		fl_set_object_color(fdui -> level_enabled_output_button, FL_COL1, FL_YELLOW);
		}
	}
else
	{
	fl_set_object_color(fdui -> level_enabled_output_button, FL_COL1, FL_YELLOW);
	}	

fl_set_button(fdui -> fft_log_scale_button, fft_log_scale_flag);
if(fft_log_scale_flag)
	{
	if(display_mode == DISPLAY_FFT) fl_show_object(fdui -> fft_log_x_axis_group);
	}
else 
	{
	fl_hide_object(fdui -> fft_log_x_axis_group);
	}

fl_set_slider_value(fdui -> scope_trigger_level_slider, scope_trigger_level);
fl_set_button(fdui -> scope_trigger_mode_button, scope_trigger_mode);
if(scope_trigger_mode == SCOPE_TRIGGER_MODE_NEG_EDGE)
	{
	fl_set_object_label(fdui -> scope_trigger_mode_button, "-");
	}
else
	{
	fl_set_object_label(fdui -> scope_trigger_mode_button, "+");
	}

sprintf(temp, "%d", scope_time_per_division_multiplier);
fl_set_object_label(fdui -> scope_speed_text, temp);
set_io_buttons(audio_mode);

fl_set_button(fdui -> scope_auto_trigger_button, scope_auto_trigger_flag);	
if(scope_auto_trigger_flag)
	{
	fl_set_object_label(fdui -> scope_auto_trigger_button, "auto");
	}
else
	{
	fl_set_object_label(fdui -> scope_auto_trigger_button, "trig");	
	}

da =  1.5 / (double)scope_sensitivity;
sprintf(temp, "%.2f", da);
fl_set_object_label(fdui -> scope_sensitivity_text, temp);
	
fl_set_button(fdui -> agc_button, agc_flag);

/* zeros if no file and startup */	
fl_set_slider_value(fdui -> equalizer_control0_slider, equalizer_slider_value[0]);
fl_set_slider_value(fdui -> equalizer_control1_slider, equalizer_slider_value[1]);
fl_set_slider_value(fdui -> equalizer_control2_slider, equalizer_slider_value[2]);
fl_set_slider_value(fdui -> equalizer_control3_slider, equalizer_slider_value[3]);
fl_set_slider_value(fdui -> equalizer_control4_slider, equalizer_slider_value[4]);
fl_set_slider_value(fdui -> equalizer_control5_slider, equalizer_slider_value[5]);
fl_set_slider_value(fdui -> equalizer_control6_slider, equalizer_slider_value[6]);
fl_set_slider_value(fdui -> equalizer_control7_slider, equalizer_slider_value[7]);
fl_set_slider_value(fdui -> equalizer_control8_slider, equalizer_slider_value[8]);
fl_set_slider_value(fdui -> equalizer_control9_slider, equalizer_slider_value[9]);
for(a = 0; a < 10; a++)
	{
	set_equalizer(a, equalizer_slider_value[a]);
	}
	
if(debug_flag)
	{
	fprintf(stderr, "load_equalizer(): equalizer_gain=%.2f\n", equalizer_gain);
	}

fl_set_slider_value(fdui -> equalizer_gain_slider, equalizer_gain);
fl_set_slider_value(fdui -> threshold_slider, threshold);
fl_set_slider_value(fdui -> on_time_slider, on_milli_seconds);
fl_set_slider_value(fdui -> off_time_slider, off_milli_seconds);
fl_set_slider_value(fdui -> audio_peak_indicator_slider, audio_peak_level);

a = 0;

if(audio_input_device_number != old_audio_input_device_number) a = 1;
if(audio_input_device_sub_number != old_audio_input_device_sub_number) a = 1;
if(audio_output_device_number != old_audio_output_device_number) a = 1;
if(audio_output_device_sub_number != old_audio_output_device_sub_number) a = 1;

/* CRASHES */
a = 0;
if(a)
	{
	stop_audio();
	set_audio_input_device_name(audio_input_device_number, audio_input_device_sub_number);
	set_audio_output_device_name(audio_output_device_number, audio_output_device_sub_number);
	start_audio();
	}

if(use_input_file_flag)
	{
	fl_hide_object(fdui -> audio_input_device_select_button);
	fl_hide_object(fdui -> audio_input_text);
	}
else
	{
	fl_show_object(fdui -> audio_input_device_select_button);
	fl_show_object(fdui -> audio_input_text);
	}

if(output_flag)
	{
	fl_hide_object(fdui -> audio_output_device_select_button);	
	fl_hide_object(fdui -> audio_output_text);
	}
else
	{	
	fl_show_object(fdui -> audio_output_device_select_button);
	fl_show_object(fdui -> audio_output_text);
	}

if(output_flag && use_input_file_flag)
	{
	fl_hide_object(fdui -> audio_mode_select_button);
	}
else
	{
	fl_show_object(fdui -> audio_mode_select_button);
	}

if(internet_mode == INTERNET_CLIENT)
	{	
	if(! internet_stream_flag)
		{
		fl_hide_object(fdui -> scope_display);
		fl_hide_object(fdui -> scope_speed_up_button);
		fl_hide_object(fdui -> scope_speed_text);
		fl_hide_object(fdui -> scope_speed_down_button);
		fl_hide_object(fdui -> scope_trigger_mode_button);
		fl_hide_object(fdui -> scope_trigger_level_slider);
		fl_hide_object(fdui -> scope_timebase_text);
		fl_hide_object(fdui -> scope_auto_trigger_button);
		fl_hide_object(fdui -> scope_sensitivity_up_button);
		fl_hide_object(fdui -> scope_sensitivity_text);
		fl_hide_object(fdui -> scope_sensitivity_down_button);
		fl_hide_object(fdui -> scope_sensitivity_label_text);
	
		fl_hide_object(fdui -> fft_display);
		fl_hide_object(fdui -> fft_log_x_axis_group);
		fl_hide_object(fdui -> fft_log_scale_button);

		fl_hide_object(fdui -> audio_control_button);
		fl_hide_object(fdui -> audio_mode_select_button);
		}

	}

return 1;
} /* end function update_gui */


int send_remote_command()
{
if(debug_flag)
	{
	fprintf(stderr, "send_remote_command(): arg none\n");
	}

if(internet_mode != INTERNET_CLIENT) return 0;
if(internet_client_sock == 0) return 0;

if(! send_status(internet_client_sock) ) return 0;

return 1;
} /* end function send_remote_command */


int ask_client_to_disconnect(int socket)
{
char temp[80];
int bytes_written;

if(debug_flag)
	{
	fprintf(stderr, "ask_client_to_disconnect(): arg socket=%d\n", socket);
	}

if(internet_mode != INTERNET_SERVER) return 0;

sprintf(temp, "xpequ client disconnect");
/* send tx buffer, password plus text */
bytes_written = write(socket, temp, strlen(temp) );
if(bytes_written < 0)
	{
	fprintf(stderr, "ask_client_to_disconnect(): could not send temp=%s ", temp);
	perror ("because");

	internet_client_sock = 0;
	
	close(socket);

	return 0;
	}

return 1;
} /* end function ask_client_to_disconnect */



int set_display_filename(char *filename)
{
char *ptr;
char temp[FILENAME_DISPLAY_SIZE];

if(debug_flag)
	{
	fprintf(stderr, "set_display_filename()_: arg filename=%s\n", filename);
	}

if(! filename) return 0;

if(strcmp(filename, "-") == 0)
	{
	strncpy(temp, "stdin", FILENAME_DISPLAY_SIZE);
	}
else
	{
	/* keep only the real filename, not the path */
	ptr = strrchr(filename, '/');
	if(! ptr)
		{
		strncpy(temp, filename, FILENAME_DISPLAY_SIZE);
		}
	else
		{
		strncpy(temp, ptr + 1, FILENAME_DISPLAY_SIZE);
		}	
	}

fl_set_object_label(fdui -> filename_indicator, temp);

return 1;
} /* end function set_display_filename */


int set_internet_server_name_indicator()
{
if(debug_flag)
	{
	fprintf(stderr,\
	"set_internet_server_name_indicator(): arg none,\n\
	using internet_mode=%d internet_connected_flag=%d internet_server_name=%s internet_host_name=%s\n",\
	internet_mode, internet_connected_flag, internet_server_name, internet_host_name);
	}

if(! internet_server_name) return 0;
if(! internet_host_name) return 0;

if(internet_mode == INTERNET_CLIENT)
	{
	if(internet_connected_flag)
		{
		fl_set_object_color(fdui -> internet_server_name_indicator, FL_GREEN, FL_GREEN);
		fl_set_object_lcolor(fdui -> internet_server_name_indicator, FL_BLACK);
		
		}
	else
		{
		fl_set_object_color(fdui -> internet_server_name_indicator, FL_RED, FL_RED);
		fl_set_object_lcolor(fdui -> internet_server_name_indicator, FL_WHITE);	
		}

	fl_set_object_label(fdui -> internet_server_name_indicator, internet_server_name);
	} /* end if internet client */

if(internet_mode == INTERNET_SERVER)
	{	
	if(internet_connected_flag)
		{
		fl_set_object_color(fdui -> internet_server_name_indicator, FL_GREEN, FL_GREEN);
		fl_set_object_lcolor(fdui -> internet_server_name_indicator, FL_BLACK);
		fl_set_object_label(fdui -> internet_server_name_indicator, internet_host_name);		
		}
	else
		{	
		fl_set_object_color(fdui -> internet_server_name_indicator, FL_DARKORANGE, FL_DARKORANGE);
		fl_set_object_lcolor(fdui -> internet_server_name_indicator, FL_WHITE);
		fl_set_object_label(fdui -> internet_server_name_indicator, "NO CLIENT");
		}
	} /* end if internet server */

return 1;
} /* end function set_internet_server_name_indicator */


int send_audio_buffer(int socket)
{
int a, bytes_written;

if(debug_flag)
	{
	fprintf(stderr, "send_audio_buffer(): arg socket=%d using audiobuf=%p abuf_size=%d\n", socket, audiobuf, abuf_size);
	}

bytes_written = 0;
while(1)
	{
	a = write(socket, audiobuf + bytes_written, abuf_size - bytes_written);
	if(a < 0)
		{
		fprintf(stderr, "send_audio_buffer(): could not send audiobuffer\n");
		perror ("because");

		internet_client_sock = 0;
	
		close(socket);

		return 0;
		}

	bytes_written += a;
	if(bytes_written == abuf_size) break;

//fprintf(stderr, "WAS while\n");
	} 

fprintf(stderr, "WAS send_audio_buffer return\n");

return 1;
} /* end function send_audio_buffer */


