
/*
xpequ copyright (c) 2007-always Jan Panteltje

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/



#include "forms.h"
#include "xpequ.h"

extern FD_xpequ *fdui;

int save_setting(char *type, char *string)
{
char pathfilename[READSIZE];
FILE *setting_file;

/* combine with home directory */
sprintf(pathfilename, "%s/.xpequ/setup/%s", home_dir, type);
setting_file = fopen(pathfilename, "w");
if(! setting_file)
	{
	fl_show_alert("Cannot open file for write:", pathfilename, "", 0);
	if(debug_flag)
		{
		fprintf(stderr, "\nCannot open setting file %s for write\n",\
		pathfilename);
		}
	return(0);
	}

fprintf(setting_file, "%s", string);
fclose(setting_file);
return(1);	
} /* end function save_setting */


char *load_setting(char *type)
{
int a;
char temp[4096];
char pathfilename[READSIZE];
FILE *setting_file;

/* combine with home directory */
sprintf(pathfilename, "%s/.xpequ/setup/%s", home_dir, type);

setting_file = fopen(pathfilename, "r");
if(! setting_file)
	{
	if(debug_flag)
		{
		fprintf(stderr, "\nCannot open setting file %s for read\n",\
		pathfilename);
		}

	return 0;
	}

a = readline(setting_file, temp);/* closes file if EOF */	
if(a != EOF) fclose(setting_file);

return( (char *) strsave(temp) );
} /* end function load_setting */


#ifdef VARIABLE_FONTSIZES
int save_fontsizes()
{
char temp[READSIZE];
//sprintf(temp, "%d", main_form_fontsize);

return 1;
);

if(! save_setting("fontsizes", temp) ) return(0);

return 1;
}/* end function save_fontsizes */


int load_fontsizes()
{
char *data_read;
 
data_read = (char *) load_setting("fontsizes");
if(! data_read) return(0);

//sscanf(data_read, "%d", &main_form_fontsize);

free(data_read);

//fl_set_browser_fontsize(fdui -> xpequ, main_form_fontsize);

return 1;
}/* end function load_fontsizes */

#endif // VARIABLE_FONTSIZES


int set_audio_output_device_name(int nr, int subnr)
{
char text[80];

if(debug_flag)
	{
	fprintf(stderr, "set_audio_output_device_name(): arg nr=%d subnr=%d using: audio_mode=%d\n", nr, subnr, audio_mode);
	}

/* prevent selection blocking when trying to open device twice */
if(audio_input_device_number == audio_output_device_number)
	{
	if(audio_input_device_sub_number == audio_output_device_sub_number)
		{
		if(audio_mode == USE_ALSA)
			{
			audio_output_device_sub_number++;
			if(audio_output_device_sub_number > AUDIO_SUB_DEVICE_LAST)
				{
				audio_output_device_sub_number = AUDIO_SUB_DEVICE_FIRST;
				audio_output_device_number++;
				if(audio_output_device_number > AUDIO_DEVICE_LAST) audio_output_device_number = AUDIO_DEVICE_FIRST;
				}
			}
		else if(audio_mode == USE_OSS)	
			{
			audio_output_device_number++;
			if(audio_output_device_number > AUDIO_DEVICE_LAST) audio_output_device_number = AUDIO_DEVICE_FIRST;
			}
		}	
	}

if(audio_mode == USE_OSS)
	{
	sprintf(text, "/dev/dsp%d", nr);
	}
else if(audio_mode == USE_ALSA)
	{
	sprintf(text, "hw:%d,%d", nr, subnr);
	}	

if(audio_output_device_name) free(audio_output_device_name);
audio_output_device_name = strsave(text);
if(! audio_output_device_name)
	{
	fprintf(stderr, "set_audio_output_device_name(): could not allocate space for audio_output_device_name\n");

	return 0;
	}

if(debug_flag)
	{
	fprintf(stderr, "audio_output_device_name=%s\n", audio_output_device_name);
	}

fl_set_object_label(fdui -> audio_output_device_select_button, audio_output_device_name);

save_audio_settings();

return 1;
} /* end function set_audio_output_device_name */


int set_audio_input_device_name(int nr, int subnr)
{
char text[80];

if(debug_flag)
	{
	fprintf(stderr, "set_audio_input_device_name(): arg nr=%d using: audio_mode=%d\n", nr, audio_mode);
	}

/* prevent selection blocking when trying to open device twice */
if(audio_input_device_number == audio_output_device_number)
	{
	if(audio_input_device_sub_number == audio_output_device_sub_number)
		{
		if(audio_mode == USE_ALSA)
			{
			audio_input_device_sub_number++;
			if(audio_input_device_sub_number > AUDIO_SUB_DEVICE_LAST)
				{
				audio_input_device_sub_number = AUDIO_SUB_DEVICE_FIRST;
				audio_input_device_number++;
				if(audio_input_device_number > AUDIO_DEVICE_LAST) audio_input_device_number = AUDIO_DEVICE_FIRST;
				}
			}
		else if(audio_mode == USE_OSS)	
			{
			audio_input_device_number++;
			if(audio_input_device_number > AUDIO_DEVICE_LAST) audio_input_device_number = AUDIO_DEVICE_FIRST;
			}
		}	
	}

if(audio_mode == USE_OSS)
	{
	sprintf(text, "/dev/dsp%d", nr);
	}
else if(audio_mode == USE_ALSA)
	{
	sprintf(text, "hw:%d,%d", nr, subnr);
	}	

if(audio_input_device_name) free(audio_input_device_name);
audio_input_device_name = strsave(text);
if(! audio_input_device_name)
	{
	fprintf(stderr, "set_audio_input_device_name(): could not allocate space for audio_input_device_name\n");

	return 0;
	}

if(debug_flag)
	{
	fprintf(stderr, "audio_input_device_name=%s\n", audio_input_device_name);
	}

fl_set_object_label(fdui -> audio_input_device_select_button, audio_input_device_name);

save_audio_settings();

return 1;
} /* end function set_audio_input_device_name */


int save_audio_settings()
{
char temp[1024];

if(debug_flag)
	{
	fprintf(stderr, "save_audio_settings(): arg none\n");
	}

if(internet_mode == INTERNET_CLIENT)
	{
	send_remote_command();
	
	return 1;
	}

sprintf(temp, "%d %d %d %d %d %d %d %d %d %d %d %d %.2f %d %d %d  %.2f %.2f %.2f %d %d",\
audio_input_device_number,\
audio_output_device_number,\
off_time_10x_flag,\
equalizer_enable_flag,\
display_mode,\
level_enabled_output_flag,\
fft_log_scale_flag,\
audio_mode,\
audio_input_device_sub_number,\
audio_output_device_sub_number,\
scope_time_per_division_multiplier,\
scope_trigger_mode,\
scope_trigger_level,\
scope_auto_trigger_flag,\
scope_sensitivity,\
agc_flag,\
threshold,\
on_milli_seconds,\
off_milli_seconds,\
internet_stream_flag,\
color_output_flag\
);

save_setting("audio_settings", temp);

return 1;
} /* end function save_audio_settings */


int load_audio_settings()
{
char *ptr;
char temp[80];
double da;

if(debug_flag)
	{
	fprintf(stderr, "load_audio_settings(): arg none\n");
	}

if(internet_mode == INTERNET_CLIENT) return 1;

ptr = (char *) load_setting("audio_settings");
if( ! ptr)
	{
	/* report about usings defaults in load settings() */
	}
else
	{
	sscanf(ptr, "%d %d %d %d %d %d %d %d %d %d %d %d %lf %d %d %d  %lf %lf %lf  %d %d",\
	&audio_input_device_number,\
	&audio_output_device_number,\
	&off_time_10x_flag,\
	&equalizer_enable_flag,\
	&display_mode,\
	&level_enabled_output_flag,\
	&fft_log_scale_flag,\
	&audio_mode,\
	&audio_input_device_sub_number,\
	&audio_output_device_sub_number,\
	&scope_time_per_division_multiplier,\
	&scope_trigger_mode,\
	&scope_trigger_level,\
	&scope_auto_trigger_flag,\
	&scope_sensitivity,\
	&agc_flag,\
	&threshold,\
	&on_milli_seconds,\
	&off_milli_seconds,\
	&internet_stream_flag,\
	&color_output_flag
	);
	}

fl_set_button(fdui -> internet_stream_button, internet_stream_flag);

fl_set_button(fdui ->  off_time_x10_button, off_time_10x_flag);
set_off_slider_bounds();

fl_set_button(fdui -> equalizer_enable_button, equalizer_enable_flag);
set_equalizer_objects(equalizer_enable_flag);

set_display_mode_button_label(display_mode);

fl_set_button(fdui -> level_enabled_output_button, level_enabled_output_flag);

fl_set_button(fdui -> fft_log_scale_button, fft_log_scale_flag);
if(fft_log_scale_flag)
	{
	if(display_mode == DISPLAY_FFT) fl_show_object(fdui -> fft_log_x_axis_group);
	}
else 
	{
	fl_hide_object(fdui -> fft_log_x_axis_group);
	}

fl_set_slider_value(fdui -> scope_trigger_level_slider, scope_trigger_level);
fl_set_button(fdui -> scope_trigger_mode_button, scope_trigger_mode);
if(scope_trigger_mode == SCOPE_TRIGGER_MODE_NEG_EDGE)
	{
	fl_set_object_label(fdui -> scope_trigger_mode_button, "-");
	}
else
	{
	fl_set_object_label(fdui -> scope_trigger_mode_button, "+");
	}

sprintf(temp, "%d", scope_time_per_division_multiplier);
fl_set_object_label(fdui -> scope_speed_text, temp);
set_io_buttons(audio_mode);

fl_set_button(fdui -> scope_auto_trigger_button, scope_auto_trigger_flag);	
if(scope_auto_trigger_flag)
	{
	fl_set_object_label(fdui -> scope_auto_trigger_button, "auto");
	}
else
	{
	fl_set_object_label(fdui -> scope_auto_trigger_button, "trig");	
	}

da =  1.5 / (double)scope_sensitivity;
sprintf(temp, "%.2f", da);
fl_set_object_label(fdui -> scope_sensitivity_text, temp);
	
fl_set_button(fdui -> agc_button, agc_flag);

high_samples = on_milli_seconds / milli_seconds_per_sample;
low_samples = off_milli_seconds / milli_seconds_per_sample;

fl_set_slider_value(fdui -> threshold_slider, threshold);
fl_set_slider_value(fdui -> on_time_slider, on_milli_seconds);
fl_set_slider_value(fdui -> off_time_slider, off_milli_seconds);

old_audio_input_device_number = audio_input_device_number;
old_audio_input_device_sub_number = audio_input_device_sub_number;

old_audio_output_device_number = audio_input_device_number;
old_audio_output_device_sub_number = audio_input_device_sub_number;

fl_set_button(fdui -> color_output_button, color_output_flag);


return 1;
} /* end function load_audio_settings */


void set_off_slider_bounds()
{
if(debug_flag)
	{
	fprintf(stderr, "set_off_slider_bounds(): arg none, using off_time_10x_flag=%d\n", off_time_10x_flag);
	}

if(off_time_10x_flag)
	{
	fl_set_slider_bounds(fdui -> off_time_slider, 40000, 1000);
	}
else
	{
	fl_set_slider_bounds(fdui -> off_time_slider, 4000, 100);
	}

} /* end function set_off_slider_bounds */


int save_equalizer(char *pathfilename)
{
int i;
FILE *fptr;

if(debug_flag)
	{
	fprintf(stderr, "save_equalizer(): arg pathfilename=%s\n", pathfilename);
	}

if(! pathfilename) return 0;

if(internet_mode == INTERNET_CLIENT)
	{
	send_remote_command();

	return 1;
	}
	
fptr = fopen (pathfilename, "w");
if(! fptr)
	{
	if(debug_flag)
		{
		fprintf(stderr, "save_equalizer(): could not open file %s for write.\n", pathfilename);
		}

	return 0;
	}

for(i = 0; i < EQ_BANDS; i++)
	{
	fprintf(fptr, "%d ", equalizer_slider_value[i]);
	}

fprintf(fptr, "%.2f", equalizer_gain);

fclose(fptr);

return 1;
} /* end function save_equalizer */


int load_equalizer(char *pathfilename)
{
int have_file, i;
FILE *fptr;

if(debug_flag)
	{
	fprintf(stderr, "load_equalizer(): arg pathfilename=%s\n", pathfilename);
	}

if(! pathfilename) return 0;

if(internet_mode == INTERNET_CLIENT) return 1;

have_file = 0;
fptr = fopen(pathfilename, "r");
if(! fptr)
	{
	if(debug_flag)
		{
		fprintf(stderr, "load_equalizer(): could not open file %s for read.\n", pathfilename);
		}

	/* so we have signal */
	equalizer_gain = 1.0;
	}
else
	{
	for(i = 0; i < EQ_BANDS; i++)
		{
		fscanf(fptr, "%d ", &equalizer_slider_value[i]);
		}

	fscanf(fptr, "%lf", &equalizer_gain);

	fclose(fptr);
	have_file = 1;
	}


/* zeros if no file and startup */	
fl_set_slider_value(fdui -> equalizer_control0_slider, equalizer_slider_value[0]);
fl_set_slider_value(fdui -> equalizer_control1_slider, equalizer_slider_value[1]);
fl_set_slider_value(fdui -> equalizer_control2_slider, equalizer_slider_value[2]);
fl_set_slider_value(fdui -> equalizer_control3_slider, equalizer_slider_value[3]);
fl_set_slider_value(fdui -> equalizer_control4_slider, equalizer_slider_value[4]);
fl_set_slider_value(fdui -> equalizer_control5_slider, equalizer_slider_value[5]);
fl_set_slider_value(fdui -> equalizer_control6_slider, equalizer_slider_value[6]);
fl_set_slider_value(fdui -> equalizer_control7_slider, equalizer_slider_value[7]);
fl_set_slider_value(fdui -> equalizer_control8_slider, equalizer_slider_value[8]);
fl_set_slider_value(fdui -> equalizer_control9_slider, equalizer_slider_value[9]);

if(debug_flag)
	{
	fprintf(stderr, "load_equalizer(): equalizer_gain=%.2f\n", equalizer_gain);
	}

fl_set_slider_value(fdui -> equalizer_gain_slider, equalizer_gain);
            
if(! have_file) return 0;

return 1;
} /* end function load_equalizer */


int set_io_buttons(int flag)
{
if(debug_flag)
	{
	fprintf(stderr, "set_io_button_colors(): arg flag=%d\n", flag);
	}

fl_set_button(fdui -> audio_mode_select_button, flag);
if(flag)
	{
	fl_set_object_color(fdui -> audio_input_device_select_button, FL_MAGENTA, FL_MAGENTA);
	fl_set_object_color(fdui -> audio_output_device_select_button, FL_MAGENTA, FL_MAGENTA);

	fl_set_object_label(fdui -> audio_mode_select_button, "OSS");
	fl_set_object_color(fdui -> audio_mode_select_button, FL_MAGENTA, FL_MAGENTA);
	}
else
	{
	fl_set_object_color(fdui -> audio_input_device_select_button, FL_COL1, FL_COL1);
	fl_set_object_color(fdui -> audio_output_device_select_button, FL_COL1, FL_COL1);

	fl_set_object_label(fdui -> audio_mode_select_button, "ALSA");
	fl_set_object_color(fdui -> audio_mode_select_button, FL_COL1, FL_COL1);
	}

return 1;
} /* end function set_io_buttons */


int set_display_mode_button_label(int mode)
{
if(debug_flag)
	{
	fprintf(stderr, "set_display_mode_button_label(): arg mode=%d\n", mode);
	}

if(display_mode == DISPLAY_NONE)
	{
	fl_hide_object(fdui -> scope_display);
	fl_hide_object(fdui -> scope_speed_up_button);
	fl_hide_object(fdui -> scope_speed_text);
	fl_hide_object(fdui -> scope_speed_down_button);
	fl_hide_object(fdui -> scope_trigger_mode_button);
	fl_hide_object(fdui -> scope_trigger_level_slider);
	fl_hide_object(fdui -> scope_timebase_text);
	fl_hide_object(fdui -> scope_auto_trigger_button);
	fl_hide_object(fdui -> scope_sensitivity_up_button);
	fl_hide_object(fdui -> scope_sensitivity_text);
	fl_hide_object(fdui -> scope_sensitivity_down_button);
	fl_hide_object(fdui -> scope_sensitivity_label_text);
	
	fl_hide_object(fdui -> fft_display);
	fl_hide_object(fdui -> fft_log_x_axis_group);
	fl_hide_object(fdui -> fft_log_scale_button);

	fl_set_object_label(fdui -> display_mode_button, "OFF");
	fl_set_object_color(fdui -> display_mode_button, FL_COL1, FL_COL1);
	}
else if(display_mode == DISPLAY_FFT)	
	{
	fl_hide_object(fdui -> scope_display);
	fl_hide_object(fdui -> scope_speed_up_button);
	fl_hide_object(fdui -> scope_speed_text);
	fl_hide_object(fdui -> scope_speed_down_button);
	fl_hide_object(fdui -> scope_trigger_mode_button);
	fl_hide_object(fdui -> scope_trigger_level_slider);
	fl_hide_object(fdui -> scope_timebase_text);
	fl_hide_object(fdui -> scope_auto_trigger_button);
	fl_hide_object(fdui -> scope_sensitivity_up_button);
	fl_hide_object(fdui -> scope_sensitivity_text);
	fl_hide_object(fdui -> scope_sensitivity_down_button);
	fl_hide_object(fdui -> scope_sensitivity_label_text);
	
	fl_set_object_label(fdui -> display_mode_button, "FFT");	
	fl_set_object_color(fdui -> display_mode_button, FL_YELLOW, FL_YELLOW);

	if( (internet_mode != INTERNET_CLIENT)  || internet_stream_flag)
		{
		fl_show_object(fdui -> fft_display);	
		fl_show_object(fdui -> fft_log_scale_button);
		if(fft_log_scale_flag)
			{
			fl_show_object(fdui -> fft_log_x_axis_group);
			}
		}
	}
else if(display_mode == DISPLAY_OSCILLOSCOPE)
	{
	fl_hide_object(fdui -> fft_display);
	fl_hide_object(fdui -> fft_log_scale_button);
	fl_hide_object(fdui -> fft_log_x_axis_group);

	fl_set_object_label(fdui -> display_mode_button, "OSC");
	fl_set_object_color(fdui -> display_mode_button, FL_CYAN, FL_CYAN);

	if( (internet_mode != INTERNET_CLIENT) || internet_stream_flag)
		{
		fl_show_object(fdui -> scope_display);
		fl_show_object(fdui -> scope_speed_up_button);
		fl_show_object(fdui -> scope_speed_text);
		fl_show_object(fdui -> scope_speed_down_button);
		fl_show_object(fdui -> scope_trigger_mode_button);
		fl_show_object(fdui -> scope_trigger_level_slider);
		fl_show_object(fdui -> scope_timebase_text);
		fl_show_object(fdui -> scope_auto_trigger_button);
		fl_show_object(fdui -> scope_sensitivity_up_button);
		fl_show_object(fdui -> scope_sensitivity_text);
		fl_show_object(fdui -> scope_sensitivity_down_button);
		fl_show_object(fdui -> scope_sensitivity_label_text);
		}
	}

/* text below display get messed up by xforms, redraw form */
fl_redraw_form(fdui -> xpequ);

return 1;
} /* end function set_display_mode_button_label */


int set_equalizer_objects(int state)
{
if(debug_flag)
	{
	fprintf(stderr, "set_equalizer_objects(): arg state=%d\n", state);
	}

if(state)
	{
	fl_show_object(fdui -> equalizer_control0_slider);
	fl_show_object(fdui -> equalizer_control1_slider);
	fl_show_object(fdui -> equalizer_control2_slider);
	fl_show_object(fdui -> equalizer_control3_slider);
	fl_show_object(fdui -> equalizer_control4_slider);
	fl_show_object(fdui -> equalizer_control5_slider);
	fl_show_object(fdui -> equalizer_control6_slider);
	fl_show_object(fdui -> equalizer_control7_slider);
	fl_show_object(fdui -> equalizer_control8_slider);
	fl_show_object(fdui -> equalizer_control9_slider);
	fl_show_object(fdui -> equalizer_gain_slider);
	}
else
	{
	fl_hide_object(fdui -> equalizer_control0_slider);
	fl_hide_object(fdui -> equalizer_control1_slider);
	fl_hide_object(fdui -> equalizer_control2_slider);
	fl_hide_object(fdui -> equalizer_control3_slider);
	fl_hide_object(fdui -> equalizer_control4_slider);
	fl_hide_object(fdui -> equalizer_control5_slider);
	fl_hide_object(fdui -> equalizer_control6_slider);
	fl_hide_object(fdui -> equalizer_control7_slider);
	fl_hide_object(fdui -> equalizer_control8_slider);
	fl_hide_object(fdui -> equalizer_control9_slider);
	fl_hide_object(fdui -> equalizer_gain_slider);
	}
return 1;
} /* end function set_equalizer_objects */

