
/*
xpequ copyright (c) 2007-always Jan Panteltje

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "forms.h"
#include "xpequ.h"

extern FD_xpequ *fdui;



char *strsave(char *s) /* save char array s somewhere */
{
char *p;

p = malloc( strlen(s) +  1);
if(! p) return 0;

strcpy(p, s);
return p;
} /* end function strsave */


void serial_device_select_button_cb(FL_OBJECT *ob, long data)
{
char *p;

if(debug_flag)
	{
	fprintf(stderr, "serial_device_select_button_cb(): arg none\n");
	}

p = (char *)fl_show_input("Enter New serial device name", serial_device_name);
if(! p) return;

if(serial_device_name) free(serial_device_name);
serial_device_name = strsave(p);
if(! serial_device_name)
	{
	fprintf(stderr, "col_pic: serial_device_select_button_cb(): could not allocate space for serial_device_name\n");
	}

fl_set_object_label(ob, serial_device_name);

save_setting("serial_device_name", serial_device_name);

} /* end function function color_output_button_cb */



void color_output_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "color_output_button_cb(): arg none\n");
	}

color_output_flag = fl_get_button(ob);

if(color_output_flag)
	{
	start_colors();
	}
else
	{
	stop_colors();
	}

save_audio_settings();
} /* end function color_output_button_cb */


void audio_control_button_cb(FL_OBJECT *ob, long data)
{
//fprintf(stderr, "WAS******************************** audio_control_button_cb() ********************************************\n");

if(internet_mode == INTERNET_CLIENT) return; // button invisble, but may be activated by server sending status.

if(audio_running_flag)
	{
	stop_audio();
	}
else
	{
	start_audio();
	}

/* no, because always on at startup */
//save_audio_settings();
} /* end function audio_control_button_cb */


void internet_stream_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "internet_stream_button_cb(): arg none\n");
	}

internet_stream_flag = fl_get_button(ob);

if(internet_mode == INTERNET_CLIENT)
	{	
	if(! internet_stream_flag)
		{
		internet_stream_client_exit_flag = 1;
/* if (audio_running then wait for server to ack streaming stopped, then stop audio */

//		if(audio_running_flag) stop_audio();
		}
	else
		{
		if(! audio_running_flag) start_audio();
		}
	}
	
update_gui_flag = 1;

save_audio_settings();
} /* end function internet_stream_button_cb */


void agc_button_cb(FL_OBJECT *ob, long data)
{
agc_flag = fl_get_button(ob);
if(agc_flag)
	{
	agc_init_flag = 0;

	agc_multiplier = 1.0;
	}

save_audio_settings();
} /* end functuon void agc_button_cb */


void scope_sensitivity_up_button_cb(FL_OBJECT *ob, long data)
{
char temp[80];
double da;

if(scope_sensitivity < SCOPE_MAX_SENSITIVITY) scope_sensitivity *= 10;

da = 1.5 / (double)scope_sensitivity;
sprintf(temp, "%.2f", da);
fl_set_object_label(fdui -> scope_sensitivity_text, temp);

save_audio_settings();
} /* end function scope_sensitivity_up_button_cb */
 

void scope_sensitivity_down_button_cb(FL_OBJECT *ob, long data)
{
char temp[80];
double da;

if(scope_sensitivity > SCOPE_MIN_SENSITIVITY) scope_sensitivity /= 10;

da = 1.5 / (double)scope_sensitivity;
sprintf(temp, "%.2f", da);
fl_set_object_label(fdui -> scope_sensitivity_text, temp);

save_audio_settings();
} /* end function scope_sensitivity_down_button_cb */


void scope_auto_trigger_button_cb(FL_OBJECT *ob, long data)
{
scope_auto_trigger_flag = fl_get_button(ob);

if(scope_auto_trigger_flag)
	{
	fl_set_object_label(fdui -> scope_auto_trigger_button, "auto");
	}
else
	{
	fl_set_object_label(fdui -> scope_auto_trigger_button, "trig");	
	}
	
save_audio_settings();
} /* end function scope_auto_trigger_button_cb */


void scope_speed_up_button_cb(FL_OBJECT *ob, long data)
{
char temp[80];

if(scope_time_per_division_multiplier < SCOPE_MAX_TIME_PER_DIVISION_MULTIPLIER) scope_time_per_division_multiplier++;

sprintf(temp, "%d", scope_time_per_division_multiplier);
fl_set_object_label(fdui -> scope_speed_text, temp);

save_audio_settings();
} /* end function scope_speed_up_button_cb */


void scope_speed_down_button_cb(FL_OBJECT *ob, long data)
{
char temp[80];

if(scope_time_per_division_multiplier > SCOPE_MIN_TIME_PER_DIVISION_MULTIPLIER) scope_time_per_division_multiplier--;

sprintf(temp, "%d", scope_time_per_division_multiplier);
fl_set_object_label(fdui -> scope_speed_text, temp);

save_audio_settings();
} /* end function scope_speed_down_button_cb */


void scope_trigger_mode_button_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_button(ob);
if(a)
	{
	scope_trigger_mode = SCOPE_TRIGGER_MODE_NEG_EDGE;
	fl_set_object_label(ob, "-");
	}
else
	{
	scope_trigger_mode = SCOPE_TRIGGER_MODE_POS_EDGE;
	fl_set_object_label(ob, "+");
	}

save_audio_settings();
} /* end function scope_trigger_mode_button_cb */


void scope_trigger_level_slider_cb(FL_OBJECT *ob, long data)
{
scope_trigger_level = fl_get_slider_value(ob);

save_audio_settings();
} /* end function scope_trigger_level_slider_cb */


void audio_mode_select_button_cb(FL_OBJECT *ob, long data)
{
if(command_line_input_device_specified_flag) return;
if(command_line_output_device_specified_flag) return;


fprintf(stderr, "WAS******************************** audio_mode_select_button_cb() ********************************************\n");

stop_audio();

audio_mode = fl_get_button(ob);
set_io_buttons(audio_mode);

set_audio_input_device_name(audio_input_device_number, audio_input_device_sub_number);
set_audio_output_device_name(audio_output_device_number, audio_output_device_sub_number);

start_audio();

save_audio_settings();
} /* end function audio_mode_select_button_cb */ 


void fft_log_scale_button_cb(FL_OBJECT *ob, long data)
{
fft_log_scale_flag = fl_get_button(ob);

if(fft_log_scale_flag)
	{
	if(display_mode == DISPLAY_FFT)
		{
		fl_show_object(fdui -> fft_log_x_axis_group);
		}
	}
else
	{
	fl_hide_object(fdui -> fft_log_x_axis_group);
	}
	
save_audio_settings();
} /* end function void fft_log_scale_button_cb */


void level_enabled_output_button_cb(FL_OBJECT *ob, long data)
{
level_enabled_output_flag = fl_get_button(ob);

save_audio_settings();
} /* end function level_enabled_output_button_cb */


void equalizer_gain_slider_cb(FL_OBJECT *ob, long data)
{
equalizer_gain = fl_get_slider_value(ob);

save_equalizer(equalizer_filename);
} /* end function equalizer_gain_slider_cb */


void display_mode_button_cb(FL_OBJECT *ob, long data)
{
display_mode++;
if(display_mode > DISPLAY_OSCILLOSCOPE)
	{
	display_mode = 0;
	} 

set_display_mode_button_label(display_mode);

save_audio_settings();
} /* end functon display_mode_button_cb */


void equalizer_enable_button_cb(FL_OBJECT *ob, long data)
{
equalizer_enable_flag = fl_get_button(ob);

set_equalizer_objects(equalizer_enable_flag);

save_audio_settings();
} /* end function void equalizer_enable_button_cb */


void fft_display_cb(FL_OBJECT *ob, long data)
{

} /* end function fft_display_cb */


void scope_display_cb(FL_OBJECT *ob, long data)
{

} /* end function scope_display_cb */


void equalizer_control0_slider_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_slider_value(ob);

if(debug_flag)
	{
	fprintf(stderr, "equalizer_control0_slider_cb(): a=%d\n", a);
	}

set_equalizer(0, a);

save_equalizer(equalizer_filename);
} /* end function equalizer_control0_slider_cb */


void equalizer_control1_slider_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_slider_value(ob);

set_equalizer(1, a);

save_equalizer(equalizer_filename);
} /* end function equalizer_control1_slider_cb */


void equalizer_control2_slider_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_slider_value(ob);

set_equalizer(2, a);

save_equalizer(equalizer_filename);
} /* end function equalizer_control2_slider_cb */


void equalizer_control3_slider_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_slider_value(ob);

set_equalizer(3, a);

save_equalizer(equalizer_filename);
} /* end function equalizer_control3_slider_cb */


void equalizer_control4_slider_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_slider_value(ob);

set_equalizer(4, a);

save_equalizer(equalizer_filename);
} /* end function equalizer_control4_slider_cb */


void equalizer_control5_slider_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_slider_value(ob);

set_equalizer(5, a);

save_equalizer(equalizer_filename);
} /* end function equalizer_control5_slider_cb */


void equalizer_control6_slider_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_slider_value(ob);

set_equalizer(6, a);

save_equalizer(equalizer_filename);
} /* end function equalizer_control6_slider_cb */


void equalizer_control7_slider_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_slider_value(ob);

set_equalizer(7, a);

save_equalizer(equalizer_filename);
} /* end function equalizer_control7_slider_cb */


void equalizer_control8_slider_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_slider_value(ob);

set_equalizer(8, a);

save_equalizer(equalizer_filename);
} /* end function equalizer_control8_slider_cb */


void equalizer_control9_slider_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_slider_value(ob);

set_equalizer(9, a);

save_equalizer(equalizer_filename);
} /* end function equalizer_control9_slider_cb */



void equalizer_display_cb(FL_OBJECT *ob, long data)
{
} /* end function equalizer_display_cb */



void off_time_x10_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "off_time_x10_button_cb(): arg none\n"); 
	}

off_time_10x_flag = fl_get_button(ob);

set_off_slider_bounds();

save_audio_settings();

} /* end function off_time_x10_button_cb */


void threshold_slider_cb(FL_OBJECT *ob, long data)
{
threshold = fl_get_slider_value(ob);

save_audio_settings();
} /* end function threshold_slider_cb */


void audio_peak_indicator_slider_cb(FL_OBJECT *ob, long data)
{
/* set from idle_cb() */
} /* end function audio_peak_indicator_slider_cb */


void on_time_slider_cb(FL_OBJECT *ob, long data)
{
on_milli_seconds = fl_get_slider_value(ob);

if(debug_flag)
	{
	fprintf(stderr, "on_milli_seconds=%.2f\n", on_milli_seconds);
	}

//(int)high_samples = (double) on_milli_seconds / (double) milli_seconds_per_sample;
high_samples = on_milli_seconds / milli_seconds_per_sample;

save_audio_settings();
} /* end function threshold_slider_cb */


void off_time_slider_cb(FL_OBJECT *ob, long data)
{
off_milli_seconds = fl_get_slider_value(ob);

if(debug_flag)
	{
	fprintf(stderr, "off_milli_seconds=%.2f\n", off_milli_seconds);
	}

//(int)low_samples = (double) off_milli_seconds / (double) milli_seconds_per_sample;
low_samples = off_milli_seconds / milli_seconds_per_sample;

save_audio_settings();
} /* end function threshold_slider_cb */


void audio_input_device_select_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "audio_input_device_select_button_cb(): arg none\n");
	}

if(command_line_input_device_specified_flag) return;

if(internet_mode != INTERNET_CLIENT) stop_audio();
	
if(audio_mode == USE_ALSA)
	{
	audio_input_device_sub_number++;
	if(audio_input_device_sub_number > AUDIO_SUB_DEVICE_LAST)
		{
		audio_input_device_sub_number = AUDIO_SUB_DEVICE_FIRST;
		audio_input_device_number++;
		if(audio_input_device_number > AUDIO_DEVICE_LAST) audio_input_device_number = AUDIO_DEVICE_FIRST;
		}
	}
else if(audio_mode == USE_OSS)
	{
	audio_input_device_number++;
	if(audio_input_device_number > AUDIO_DEVICE_LAST) audio_input_device_number = AUDIO_DEVICE_FIRST;
	}
set_audio_input_device_name(audio_input_device_number, audio_input_device_sub_number);

if(internet_mode != INTERNET_CLIENT) start_audio();

save_audio_settings();

return;
} /* end function audio_input_device_select_button_cb */


void audio_output_device_select_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "audio_output_device_select_button_cb(): arg none\n");
	}

if(command_line_output_device_specified_flag) return;

if(internet_mode != INTERNET_CLIENT) stop_audio();

if(audio_mode == USE_ALSA)
	{
	audio_output_device_sub_number++;
	if(audio_output_device_sub_number > AUDIO_SUB_DEVICE_LAST)
		{
		audio_output_device_sub_number = AUDIO_SUB_DEVICE_FIRST;
		audio_output_device_number++;
		if(audio_output_device_number > AUDIO_DEVICE_LAST) audio_output_device_number = AUDIO_DEVICE_FIRST;
		}
	}
else if(audio_mode == USE_OSS)	
	{
	audio_output_device_number++;
	if(audio_output_device_number > AUDIO_DEVICE_LAST) audio_output_device_number = AUDIO_DEVICE_FIRST;
	}
set_audio_output_device_name(audio_output_device_number, audio_output_device_sub_number);

if(internet_mode != INTERNET_CLIENT) start_audio();

save_audio_settings();

return;
} /* end function audio_output_device_select_button_cb */


void exit_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "exit_button_cb(): arg none\n");
	}

internet_stream_client_exit_flag = 1;

stop_audio();

save_audio_settings();

ask_client_to_disconnect(internet_client_sock);

sleep(1);

stop_internet();

exit(0);
} /* end function exit_button_cb */


/* signal handler */
void one_second_tick(int sig)
{
//#define USE_TIMER
#ifdef USE_TIMER
time_t now;
struct tm *broken_time;
int current_seconds, alarm_seconds, remaining_seconds, r_hours, r_minutes, r_seconds;

now = time(0); //  + 3600 * offset;
broken_time = localtime (&now);

/*
sprintf(temp,\
"AUTO\n%02d:%02d.%02d",\
broken_time -> tm_hour, broken_time -> tm_min, broken_time -> tm_sec);
fl_set_object_label(fdui -> timed_play_button, temp);
*/

ogettime(weekday, month, &monthday, &hour, &minute, &second, &year);

if( (hour == alarm_hour) && (minute == alarm_minute) && (second == 0) )
	{
	if(debug_flag)
		{
		fprintf(stderr, "time_match\n");
		}

//	time_match_flag = 1;
	}
else
	{
//	time_match_flag = 0;
	}

alarm_seconds = (3600 * alarm_hour ) + (60 * alarm_minute); 
current_seconds = (3600 * hour) + (60 * minute) + second;
remaining_seconds = alarm_seconds - current_seconds;
if(remaining_seconds < 0) remaining_seconds += 24 * 3600;
r_hours = remaining_seconds / 3600;
r_minutes = (remaining_seconds - (3600 * r_hours) ) / 60;
r_seconds = remaining_seconds - (3600 * r_hours) - (60 * r_minutes);

if(debug_flag)
	{
	fprintf(stderr,\
	"alarm_seconds=%d current_seconds=%d remaining_seconds=%d r_hours=%d r_minutes=%d r_seconds=%d\n",\
	alarm_seconds, current_seconds, remaining_seconds,\
	r_hours, r_minutes, r_seconds);
	}
#endif // USE_TIMER

fl_add_signal_callback(SIGALRM, (FL_SIGNAL_HANDLER)one_second_tick, NULL);

/* reenable the timer */
alarm(1);
} /* end function one_second_tick (signal handler) */


int set_color_output_button(int state)
{
if(color_output_flag)
	{
	fl_set_button(fdui -> color_output_button, 1);
	fl_set_object_color(fdui -> color_output_button, FL_DARKORANGE, FL_DARKORANGE);
	}
else
	{
	fl_set_button(fdui -> color_output_button, 0);
	fl_set_object_color(fdui -> color_output_button, FL_COL1, FL_COL1);
	}

return 1;
} /* end function set_color_output_button */

